<!DOCTYPE html>
</html>
<head>
    <meta charset="utf-8">
</head>
<body>
<h3>日漫测试</h3>
<div id="login">
     <div>
      <input id="btnModeZip" type="button" value="上传zip" onclick="zipmode()" /> 
      <input id="btnModeImage" type="button" value="上传图片" onclick="imgmode()" /> 
      <div id="zipMode", hidden=true>
         上传zip文件（zip格式，压缩包和图片由字母和数字命名）
         <input type="file" name="file" id="file", accept=".zip">
      </div>
       <div id="imgMode", hidden=true>
         上传图片
      <input type="file" id="imageFile" accept="image/*">
      </div>
    <div>
        选择模型
        最近收敛
        <input id="btnSend0" type="button" value="大模型" onclick="send(0)" /> 
        <input id="btnSend1" type="button" value="男生基准非抠背模型" onclick="send(1)" hidden=True/> 
        <input id="btnSend2" type="button" value="女生抠背stylegan模型" onclick="send(2)" hidden=True/>
    </div>
    <div>
       <input id="btnMode" type="button" value="提交" onclick="generate()" disabled=true/> 
    </div>
    <div>
        <img id="ItemPreview" src="">
    </div>
   
        <div>
            来自服务端的消息
        </div>
        <textarea id="txtContent" cols="50" rows="10" readonly="readonly"></textarea>
    </div>

</body>
<script>
    function sleep(ms) {
            return new Promise(resolve => setTimeout(resolve, ms));
        }

    var socket;
    var current=0;
    var total;
    var beforetime;
    var img;
    var model_num;
    var processing = 0;

    async function clearNoNum(obj){
        if(obj.value !=''&& obj.value.substr(0,1) == '.'){
            obj.value="";
        }
        obj.value = obj.value.replace(/[^\d.]/g,"");
        if(Number(obj.value)<0 || Number(obj.value)>14)
            obj.value="";
    }
    
    async function zipmode(){
        zipMode.hidden = false;
        imgMode.hidden = true;
        btnModeZip.disabled = true;
        btnModeImage.disabled = false;
        
    }
    
    async function imgmode(){
        imgMode.hidden = false;
        zipMode.hidden = true;
        btnModeZip.disabled = false;
        btnModeImage.disabled = true;
    }

    
    async function send(model_num_local) {
        model_num = model_num_local;
        btnMode.disabled = false;
        if (model_num_local==0){
            btnSend0.disabled = true;
            btnSend1.disabled = false;
            btnSend2.disabled = false;
        }
        else if(model_num_local==1){
            btnSend0.disabled = false;
            btnSend1.disabled = true;
            btnSend2.disabled = false;
        }
        else{
            btnSend0.disabled = false;
            btnSend1.disabled = false;
            btnSend2.disabled = true;
        }
  
    }
    
    
    
     async function generate() {
        
        const toBase64 = file => new Promise((resolve, reject) => {
            const reader = new FileReader();
            reader.readAsDataURL(file);
            reader.onload = () => resolve(reader.result);
            reader.onerror = error => reject(error);
        });

        var xhr = new XMLHttpRequest();
      
        xhr.open("POST", "http://10.91.4.14:9995", true);
        
        var form;
        if(btnModeZip.disabled){
            var zip_file = document.querySelector("#file").files[0];
            form = new FormData();
            form.append("file", zip_file);
            form.append("model_num", model_num);
            form.append("ops", "GenerateZip");
            
            xhr.responseType= "blob";
            xhr.onload = function (oEvent) {
                console.log("success")
                var blob = new Blob([xhr.response], {type: "application/zip"});
                var fileName = "return_img.zip";
                if (navigator.msSaveOrOpenBlob) {
                    navigator.msSaveOrOpenBlob(blob, fileName);
                }        
                else{ 
                    var a = document.createElement("a");
                    document.body.appendChild(a);
                    a.style = "display:none";
                    var url = window.URL.createObjectURL(blob);
                 
                    a.href = url;
                    a.download = fileName;
                    a.click();
                    window.URL.revokeObjectURL(url);
                    a.remove();
                
                }
                processing = 0;
                btnMode.disabled = false;
            };
          
            xhr.responseType = "arraybuffer";    
        }
        else{
            xhr.responsetype = "json";
            var file = document.querySelector("#imageFile").files[0];
            form = new FormData();
            form.append("file", file);
            form.append("model_num", model_num);
            form.append("ops", "GenerateImg");
            extension = "."+imageFile.value.split('.').pop()
            $("txtContent").value += extension;
            form.append("postfix", extension);
            
         
            xhr.onload = function (oEvent) {
                console.log("success")
                var jsonResponse = JSON.parse(xhr.responseText);
                var count = jsonResponse.count
                if(count==0)
                    $("txtContent").value += "无人脸";
                else
                    document.getElementById("ItemPreview").src = "data:image/jpg;base64," + jsonResponse.img;
                processing = 0;
                btnMode.disabled = false;
            };
        
            
        }
        
      
        try {
            xhr.send(form);
            btnMode.disabled = true;
         } catch(err) {
          $("txtContent").value += "请求超时";
        }    
        
                  
        //xhr.send(JSON.stringify(str2));
        
        /* xhr.onreadystatechange = function () {
            if (xhr.status==201){
                $("txtContent").value += "waiting";
            }
            else if (xhr.status==202 && processing==0){
                $("txtContent").value += "processing";
                processing = 1;
            }
        };*/
              
        
    }
    
  

    function $(id) { return document.getElementById(id); }
    
</script>
</html>